import os

from PySide2 import QtCore
from PySide2.QtCore import QFile
from PySide2.QtGui import Qt
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QDialog, QTableWidgetItem


class DgTest(QDialog):
    def __init__(self,list_table,parent=None):
        self.__parent=parent
        self.load_ui()
        self.__ui.tableView.setColumnCount(5)
        cont_row=len(list_table)
        self.__ui.tableView.setRowCount(cont_row)
        self.__ui.tableView.setColumnWidth(0, 100)
        self.__ui.tableView.setColumnWidth(1, 80)
        self.__ui.tableView.setColumnWidth(2, 80)
        for i,row in  enumerate(list_table):
            bound_cs=row['bound_cs']
            r_col_1=QTableWidgetItem(row['name'])
            r_col_1.setFlags(QtCore.Qt.ItemIsUserCheckable |
                          QtCore.Qt.ItemIsEnabled)
            r_col_1.setCheckState(QtCore.Qt.Unchecked)
            r_col_2=QTableWidgetItem(str(bound_cs.xmin))
            r_col_2.setTextAlignment(Qt.AlignRight)
            r_col_3=QTableWidgetItem(str(bound_cs.ymin))
            r_col_3.setTextAlignment(Qt.AlignRight)
            r_col_4=QTableWidgetItem(str(bound_cs.xmax))
            r_col_4.setTextAlignment(Qt.AlignRight)
            r_col_5=QTableWidgetItem(str(bound_cs.ymax))
            r_col_5.setTextAlignment(Qt.AlignRight)

            self.__ui.tableView.setItem(i,0,r_col_1)
            self.__ui.tableView.setItem(i,1,r_col_2)
            self.__ui.tableView.setItem(i,2,r_col_3)
            self.__ui.tableView.setItem(i,3,r_col_4)
            self.__ui.tableView.setItem(i,4,r_col_5)
        self.__ui.tableView.itemClicked.connect(self.__handleItemClicked)
        self.__ui.tableView.resizeColumnsToContents()
    def __handleItemClicked(self,item):
        if item.checkState() == QtCore.Qt.Checked:
            print("select")
    def load_ui(self):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__), "TestDlg.ui")
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        self.__ui  = loader.load(ui_file,self.__parent)
        ui_file.close()
    def show(self):
        #isNotSelect=self.__isSelectObj()

        self.__ui.exec()